using System;
using System.Drawing;
using System.IO;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Serial_Communicator
{
	/// <summary>
	/// Summary description for Configure.
	/// </summary>
	public class Configure : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button SaveBtn;
		private System.Windows.Forms.Button CancelBtn;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox TextBox;
		private System.Windows.Forms.ComboBox BaudList;
		private System.Windows.Forms.Label label1;

		private string fname;

		public Configure(string fname)
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			this.fname = fname;
			this.TextBox.Text = "Config file: \'"+fname+"\'";
			try
			{
				string[] names = Enum.GetNames(typeof(SerialPorts.LineSpeed));
				for(int i = 0; i < names.Length; i++)
				{
					this.BaudList.Items.Add(Enum.Parse(typeof(SerialPorts.LineSpeed), names[i]));
				}
				this.BaudList.SelectedIndex = 0;
			}
			catch
			{
				return;
			}
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Configure));
			this.SaveBtn = new System.Windows.Forms.Button();
			this.CancelBtn = new System.Windows.Forms.Button();
			this.TextBox = new System.Windows.Forms.TextBox();
			this.BaudList = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// SaveBtn
			// 
			this.SaveBtn.Location = new System.Drawing.Point(48, 73);
			this.SaveBtn.Name = "SaveBtn";
			this.SaveBtn.Size = new System.Drawing.Size(48, 24);
			this.SaveBtn.TabIndex = 0;
			this.SaveBtn.Text = "Save";
			this.SaveBtn.Click += new System.EventHandler(this.button1_Click);
			// 
			// CancelBtn
			// 
			this.CancelBtn.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.CancelBtn.Location = new System.Drawing.Point(112, 73);
			this.CancelBtn.Name = "CancelBtn";
			this.CancelBtn.Size = new System.Drawing.Size(48, 23);
			this.CancelBtn.TabIndex = 1;
			this.CancelBtn.Text = "Cancel";
			this.CancelBtn.Click += new System.EventHandler(this.CancelBtn_Click);
			// 
			// TextBox
			// 
			this.TextBox.Location = new System.Drawing.Point(8, 8);
			this.TextBox.Name = "TextBox";
			this.TextBox.ReadOnly = true;
			this.TextBox.Size = new System.Drawing.Size(192, 20);
			this.TextBox.TabIndex = 2;
			this.TextBox.Text = "";
			this.TextBox.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// BaudList
			// 
			this.BaudList.Location = new System.Drawing.Point(80, 40);
			this.BaudList.Name = "BaudList";
			this.BaudList.Size = new System.Drawing.Size(121, 21);
			this.BaudList.TabIndex = 3;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 43);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(64, 16);
			this.label1.TabIndex = 4;
			this.label1.Text = "Baud Rate";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// Configure
			// 
			this.AcceptButton = this.SaveBtn;
			this.AutoScale = false;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.CancelBtn;
			this.ClientSize = new System.Drawing.Size(208, 107);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.BaudList);
			this.Controls.Add(this.TextBox);
			this.Controls.Add(this.CancelBtn);
			this.Controls.Add(this.SaveBtn);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "Configure";
			this.ShowInTaskbar = false;
			this.Text = "Configure Port";
			this.ResumeLayout(false);

		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{
			// Open text definitions file in write-only mode.
			FileStream fs = new FileStream(fname, FileMode.Create, FileAccess.Write);
			StreamWriter sw = new StreamWriter(fs);

			// Set file pointer to beginning of file.
			sw.BaseStream.Seek(0, SeekOrigin.Begin);

			// Write all config members.
			sw.WriteLine("<Port Name>      :COM{0}:",	fname[4]);
			sw.WriteLine("<Baud Rate>      :{0}",	this.BaudList.Text.Substring(5));
			sw.WriteLine("<CTS Flow>       :False");
			sw.WriteLine("<DSR Flow>       :False");
			sw.WriteLine("<DTR Ctrl>       :0");
			sw.WriteLine("<DSR Sense>      :False");
			sw.WriteLine("<TX Continue>    :True");
			sw.WriteLine("<TX Xoff Flow>   :False");
			sw.WriteLine("<RX Xoff Flow>   :False");
			sw.WriteLine("<Error Replace>  :False");
			sw.WriteLine("<Null Discard>   :False");
			sw.WriteLine("<RTS Control>    :0");
			sw.WriteLine("<Abort On Error> :False");
			sw.WriteLine("<Xon Limit>      :0");
			sw.WriteLine("<Xoff Limit>     :0");
			sw.WriteLine("<Bits/Byte>      :8");
			sw.WriteLine("<Parity>         :0");
			sw.WriteLine("<Stop Bits>      :0");
			sw.WriteLine("<Xon Char>       :17");
			sw.WriteLine("<Xoff Char>      :19");
			sw.WriteLine("<Error Char>     :63");
			sw.WriteLine("<EOF Char>       :26");
			sw.WriteLine("<Event Char>     :0");
			sw.WriteLine("<Handshaking>    :0");
			sw.WriteLine("<RX Q Length>    :0");
			sw.WriteLine("<TX Q Length>    :0");
			sw.WriteLine("<TX Timeout(M)>  :0");
			sw.WriteLine("<TX Timeout(C)>  :0");
			sw.WriteLine("<Receive Mode>   :True");

			// Flush to file & close.
			sw.Flush();
			fs.Close();
			this.Close();
		}

		private void CancelBtn_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}
	}
}
