using System;

namespace Serial_Communicator
{
	/// <summary>
	/// Summary description for OpenPortMenuItem.
	/// </summary>
	public class OpenPortMenuItem : System.Windows.Forms.MenuItem
	{
		public delegate void OpenPortEventHandler(object o, OpenPortEventArgs e);
		public event OpenPortEventHandler PortClick;
		private int index;
		System.Windows.Forms.MenuItem parent;
	
		public OpenPortMenuItem(int index, System.Windows.Forms.MenuItem parentMenu)
		{
			this.index = index;
			this.parent = parentMenu;
			this.PortClick += new OpenPortEventHandler(OnPortClick);		
		}

		protected override void OnClick(EventArgs e)
		{
			if(PortClick != null)
			{
				OpenPortEventArgs args = new OpenPortEventArgs(this.index, this.parent);
				PortClick(this, args);
			}
		}

		protected void OnPortClick(object sender, OpenPortEventArgs e)
		{
			base.OnClick(e);
		}
	}	
}
